function drawArea


global crossArea
global areaIterpolated
global area
global tubeLengthSmooth
global tubeLengthGeometric


if isempty( area ) || isempty( tubeLengthSmooth ) || ...
    isempty( areaIterpolated ) || ... 
    isempty( crossArea  ) || isempty( tubeLengthGeometric ) || ...
    ~isequal( size( crossArea ), size( tubeLengthGeometric )) || ...
    length( areaIterpolated ) > length( tubeLengthSmooth ) || ...
    ~isequal( size( area ), size( tubeLengthSmooth ))
  return
end

persistent areaWindow

if isempty( areaWindow )  || ~ishandle( areaWindow )
  areaWindow = figure( 'Name', 'Area', ...
                       'NumberTitle', 'off', ...
                       'HandleVisibility', 'off', ...
                       'IntegerHandle', 'off' );
end

persistent areaAxes

if isempty( areaAxes )  || ~ishandle( areaAxes )
  areaAxes = axes( 'Parent', areaWindow );
%                  'Position', [0.1 0.05 0.85 0.9] );
  set(get( areaAxes,'XLabel'),'String','Distance from glottis in mm')
  set(get( areaAxes,'YLabel'),'String','Area in square mm')
  set( areaAxes, 'XGrid','on', 'YGrid','on' )
end

%if ~isreal( tubeLengthGeometric  )
%  tubeLengthGeometric
%end   
%if ~isreal( crossArea  )
%  crossArea
%end   
%if ~isreal( tubeLengthSmooth  )
%  tubeLengthSmooth
%end   
%if ~isreal( areaIterpolated  )
%  areaIterpolated
%end   
%if ~isreal(tubeLengthSmooth   )
%  tubeLengthSmooth
%end   
%if ~isreal( area  )
%  area
%end   


set( areaAxes, 'NextPlot', 'replacechildren' )
%LG commented out for class
% plot( tubeLengthGeometric, crossArea,'r-',  'Parent', areaAxes  )
% 
% set( areaAxes, 'NextPlot', 'add' )
% plot( tubeLengthSmooth(1:length(areaIterpolated)), areaIterpolated, ... 
%       'g:', 'Parent', areaAxes  )
plot( tubeLengthSmooth, area, 'b-', 'Parent', areaAxes  )

%legend( areaAxes, 'Section Areas', 'Interpolated Areas', 'Smoothed Areas', 0 )


%persistent legendAxes

%if isempty( legendAxes )  || ~ishandle( legendAxes )
%  legendAxes = axes( 'Parent', areaWindow, ...
%                     'Position', [0.1 0.05 0.85 0.25], ...
%                     'Xlim', [0 3], 'Ylim', [0 4] );
%end

%set( legendAxes, 'NextPlot', 'replacechildren' )
%plot( [0.2 1], [1 1],'r-',  'Parent', legendAxes  )

%set( legendAxes, 'NextPlot', 'add' )
%plot( [0.2 1], [2 2], 'g:', 'Parent', legendAxes  )
%plot( [0.2 1], [3 3], 'b-', 'Parent', legendAxes  )
