function drawFreq

persistent freqWindow 
persistent freqAxes

global formantFreq
global bandwidths

if isempty( freqWindow ) || ~ishandle( freqWindow )
  freqWindow = figure( 'Name', 'Spectrum', ...
                       'NumberTitle', 'off', ...
                       'HandleVisibility', 'off', ...
                       'IntegerHandle', 'off' );
end

if isempty( freqAxes )  || ~ishandle(freqAxes  )
  freqAxes = axes( 'Parent', freqWindow, ...
                   'NextPlot', 'replacechildren' );
  set(get( freqAxes,'XLabel'),'String','Frequency in Hz')
  set(get( freqAxes,'YLabel'),'String','Magnitude in dB')
end
  

global freq
global magnitude

if isempty( freq ) || isempty( magnitude ) || ...
    ~isempty( find( size( freq ) ~= size( magnitude ) ))
  return
end



plot( freq, 10*log(magnitude), 'Parent', freqAxes )
text (4000,min(magnitude)+5,num2str(fix(formantFreq(1:5))),'Parent', freqAxes )
% sound = syn_buzz (10000,formantFreq,bandwidths,120,.5);
% title (['F =' num2str(formantFreq')],'Parent', freqAxes );

global play

if (play); p; end;
