% evaluate fixed parameters

%    ============================================================================
%      CASY_EFIX.C  - evaluate fixed parameters

%        Includes:
%  	EVAL_FIX_LARYNX
%  	EVAL_FIX_VELUM
%  	EVAL_FIX_TEETHLIP
%  	EVAL_FIX_LIP
%  	EVAL_FIX_TERMINUS
%    ============================================================================

%    ============================================================================
%      EVAL_FIX_LARYNX (1):  posterior edge of larynx

%      Y:  forced to VAR_Larynx.coord.Y
%    ============================================================================

%  void eval_fix_Larynx() 
%  {

%    FIX_Larynx.coord.y = VAR_Larynx.coord.y;
%    straight_seg( & SEG_FIX_Larynx_Periarytenoid );

%  } /* eval_fix_Larynx */

FIX_Larynx(2) = VAR_Larynx(2)


%  /*
%    ============================================================================
%      EVAL_FIX_VELUM (5)  - position of velum

%      When computed by the model, FIX and CMP Velum are the same point, 
%      determined by an offset of KEY_Nasal*GEO_Veluum.polar.len
%      along velum declination angle GEO_Velum.polar.ang.  
%      If FIX_Velum is positioned interactively, CMP_Velum represents the 
%      model's best fit to the specified position.
%    ============================================================================
%  */

%  void eval_fix_Velum() 
%  {
%    double len;

%    len = sqrt( KEY_Nasal.polar.len ) * GEO_Velum.polar.len;
%    CMP_Velum.coord.x = FIX_Velum.coord.x = 
%         FIX_PharynxHi.coord.x + len * cos(DEG2RAD(GEO_Velum.polar.ang));
%    CMP_Velum.coord.y = FIX_Velum.coord.y = 
%         FIX_PharynxHi.coord.y - len * sin(DEG2RAD(GEO_Velum.polar.ang));
%  }


% !!!! very strange ????


len = sqrt( KEY_Nasal(3) ) * GEO_Velum(3) % possible second mult must be in sqrt?
FIX_Velum(1:2) = FIX_PharynxHi(1:2) + ...
                  len * [ cos(pi/180 * GEO_Velum(4)) sin(pi/180 * GEO_Velum(4)) ]
            % strange: why translate degrees int radians? 
CMP_Velum.coord(1:2) = FIX_Velum(1:2) 


%  /*
%    ============================================================================
%      EVAL_FIX_TEETHLIP (9):  intersection of upper teeth and upper lip
%    ============================================================================
%  */

%  void eval_fix_TeethLip() 
%  {

%    FIX_TeethLip.coord.x = FIX_Teeth.coord.x + GEO_FixTeeth2TeethLip.polar.len;
%    FIX_TeethLip.coord.y = FIX_Lip.coord.y; 
  
%    straight_seg( & SEG_FIX_Teeth_TeethLip );
%    straight_seg( & SEG_FIX_TeethLip_Lip );
%  } 


FIX_TeethLip(1) = FIX_Teeth(1) + GEO_FixTeeth2TeethLip(3)
FIX_TeethLip(2) = FIX_Lip(2)


%  /*
%    ============================================================================
%      EVAL_FIX_LIP (10):  outer edge of upper lip
%    ============================================================================
%  */

%  void eval_fix_Lip() 
%  {

%    FIX_Lip.coord.x = FIX_Teeth.coord.x + KEY_FixLip.coord.x + KEY_VarLip.coord.x;
%    FIX_Lip.coord.y = FIX_Teeth.coord.y - KEY_FixLip.coord.y - KEY_VarLip.coord.y;

%    straight_seg( & SEG_FIX_Lip_Terminus );
%  } 

FIX_Lip = FIX_Teeth + ...
  [ (KEY_FixLip(1) + KEY_VarLip(1) )  (KEY_FixLip(2) - KEY_VarLip(2) ) ]


%  /*
%    ============================================================================
%      EVAL_FIX_TERMINUS (11):  upper tube termination
%    ============================================================================
%  */

%  void eval_fix_Terminus() 
%  {
%    FIX_Terminus.coord.x = FIX_Lip.coord.x + 
%                           GEO_FixTerminus.polar.len * 
%                             cos( GEO_FixTerminus.polar.ang );
%    FIX_Terminus.coord.y = FIX_Lip.coord.y + 
%                           GEO_FixTerminus.polar.len * 
%                             sin( GEO_FixTerminus.polar.ang );

%    straight_seg( & SEG_FIX_Lip_Terminus );
%  } 

FIX_Terminus = FIX_Lip + ...
   GEO_FixTerminus(3) * [ cos( GEO_FixTerminus(4) ) sin( GEO_FixTerminus(4) ) ]
