% plotting outline on graphic window

function plotting

persistent VTWindow
persistent VTAxes

if isempty( VTWindow ) || ~ishandle( VTWindow )
  VTWindow = figure( 'Name', 'Vocal Tract', ...
                     'NumberTitle', 'off', ...
                     'IntegerHandle', 'off', ...
                     'HandleVisibility', 'callback' );
end

if isempty( VTAxes ) || ~ishandle( VTAxes )
  VTAxes = axes( 'Parent', VTWindow );
  set(get( VTAxes,'XLabel'),'String','in mm')
  set(get( VTAxes,'YLabel'),'String','in mm')
end

% plot outlines
global UpperOutline
global BottomOutline 

global KeyPts
global GeoPts

global SEG_Bezier_fix_Velum_VelMax
global SEG_Bezier_fix_VelMax_Maxilla
global SEG_Bezier_fix_Maxilla_Alveolus


% next operation will erase picture
set( VTAxes, 'NextPlot', 'replacechildren' )

plot( UpperOutline(:,1), UpperOutline(:,2), 'b-', 'Parent', VTAxes )    
     % upper outline: red,  star  markers


% subsecond plots not destroy the pevious 
set( VTAxes, 'NextPlot', 'add' )


if ~isreal( BottomOutline )
  BottomOutline
end   

plot( BottomOutline(:,1), BottomOutline(:,2), 'b-', 'Parent', VTAxes )   
     % lower outline: cyan, cross markers

% global CMP_TipCircle
%   plot( CMP_TipCircle(1), CMP_TipCircle(2), 'g+', 'MarkerSize',20, ...
% 'Parent', VTAxes  )

global plotGrid

if plotGrid
global gridLines

for i = 1:size(gridLines,1)
  temp = squeeze(gridLines(i,:,:));
  plot( temp(1,:), temp(2,:), 'g', 'Parent', VTAxes )
end


global midPoints

plot( midPoints(1,:), midPoints(2,:), 'o', 'Color', [1 0.65 0 ], 'MarkerFaceColor', [1 0.65 0 ], 'Parent', VTAxes  )


global crossSection

if ~isempty( crossSection )
  delta = 0.5* crossSection';
  a = midPoints - delta; 
  b = midPoints + delta;

  for i = 1:size( midPoints, 2 )
    plot( [a(1,i) b(1,i)], [a(2,i) b(2,i)], '-', 'Color', [1 0.65 0 ], 'Parent', VTAxes  )
  end
end
end

% LG comment
%for i = GeoPts
%   plot( i.coords(1), i.coords(2), 'go', 'MarkerSize',12, ...
%         'MarkerFaceColor','g', ...
%         'ButtonDownFcn', ['startGeo ' i.Tags], 'Parent', VTAxes )
% end

for i = KeyPts
  plot( i.coords(1), i.coords(2), 'r+', 'MarkerSize',12, ...
        'ButtonDownFcn', ['startKey ' i.Tags], 'Parent', VTAxes )
end

global TUN_GridCenter

plot(  TUN_GridCenter(1),  TUN_GridCenter(2), 'ms', 'MarkerSize', 6, ...
         'MarkerFaceColor','m', ...
         'ButtonDownFcn', 'startCenter', 'Parent', VTAxes )



drawArea
drawFreq
